#include <iostream>

const int maxn = 100000 + 10;
int a[maxn], n;

void solve() 
{
    int ans = 0, last;
    for (int mask = 1 ; mask < (1 << n) ; ++mask) 
    {    
        ++ans;
        last = 0;
        for (int i = 1 ; i <= n ; ++i) 
        {
            if (mask & (1 << i-1))
            {
                if (last > a[i]) 
                {
                    --ans;
                    break;
                } else last = a[i];
            } 
        }

    }

    std::cout << ans << '\n';
}

void fastIO() 
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void read() 
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
        std::cin >> a[i];
}

int main () 
{
    fastIO();
    read();
    solve();

    return 0;
}