#include <iostream>

const int maxn = 100000 + 10;
const int mod = 998244353;

int a[maxn], n;
int dp[maxn];

void solve() 
{    
    std::fill(dp, dp+maxn, 1);
    int ans = 0;

    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = i-1 ; j >= 1 ; --j)
        {
            if (a[i] >= a[j]) dp[i] += dp[j];
            if (dp[i] >= mod) dp[i] -= mod;
        }
        
        ans += dp[i];
        if (ans >= mod) ans -= mod;
    }

    std::cout << ans << '\n';
}

void fastIO() 
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void read() 
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
        std::cin >> a[i];
}

int main () 
{
    fastIO();
    read();
    solve();

    return 0;
}