#include <iostream>
#include <fstream>
#include <cstring>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <time.h>
using namespace std;
const int maxn = 1e6+10, maxk = 1e6+10;

int a[maxn], n, diff, max_value;
bool used[maxn];
vector < int > v;
unordered_set < int > s;

ofstream fout;

void build() {

    ifstream fin("constraints.txt");
    fin.seekg(0);
    fout.seekp(0);

    int min_n, max_n, diffmin, diffmax, mina, maxa;
    fin >> min_n >> max_n;    
    fin >> mina >> maxa;    

    std::cout << "here: " << min_n << ' ' << max_n << ' ' << mina << ' ' << maxa << '\n';

    n = rand()%(max_n - min_n + 1) + min_n;

    a[1] = rand()%(maxa - mina + 1) + mina; 
    v.push_back(a[1]);
    s.insert(a[1]);
    int chance = rand()%(n-(int)sqrt(n)/2+1)+sqrt(n)/2;

    for (int i = 2 ; i <= n ; ++i) {

        if (i < (int)sqrt(n) || rand()%chance == 0) {

            int curr;
            do curr = rand()%(maxa - mina + 1) + mina;
            while (s.count(curr));
            a[i] = curr;
            v.push_back(curr);
            s.insert(curr);

        } else {

            a[i] = v[rand()%(int)v.size()];

        }

    }

    a[rand()%n+1] = maxa;
    std::cout << n << '\n';
    for (int i = 1 ; i <= n ; ++i) {

        if (i != 1) std::cout << ' ';
        std::cout << a[i];

    }

    fout << '\n';
    fout.close();
    fin.close();

}

int main (int argc, char** argv) {

    srand(time(nullptr));

    if (argc != 2) {

        cout << "There should be exactly one argument - the name of the in file!\n";
        return 0;

    }

    fout.open(argv[1]);
    build();
    
    return 0;

}