#include <iostream>
#include <fstream>
#include <cstring>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <time.h>
using namespace std;
const int maxn = 1e6+10, maxk = 1e6+10;

int a[maxn], n, k, max_value, kconst;
bool used[maxn];

unordered_map < int, int > mp;
unordered_set < int > s;

ofstream fout;

void build() {

    ifstream fin("constraints.txt");

    int min_n, max_n;
    int min_a, max_a;
    fin >> min_n >> max_n;    
    fin >> min_a >> max_a;  

    n = rand()%(max_n - min_n + 1) + min_n;

    int rnd = rand()%(max_a-min_a+1)+min_a;
    int rnd2 = rand()%(max_a-min_a+1)+min_a;

    if (rnd2 == rnd) {

        if (rnd == 1) ++rnd2;
        else --rnd;

    }

    if (rnd2 < rnd) swap(rnd2, rnd);
    int chance = 25 + rand()%51;


    for (int i = 1 ; i <= n ; ++i) {
    
        if (rand() % 100 < chance) a[i] = rnd;
        else a[i] = rnd2;
    
    }

    fout << n << '\n';
    for (int i = 1 ; i <= n ; ++i) {

        if (i >= 2) fout << ' ';
        fout << a[i];

    }

    fout << '\n';

}

int main (int argc, char** argv) {

    srand(time(nullptr));

    if (argc != 2) {

        cout << "There should be exactly one argument - the name of the in file!\n";
        return 0;

    }

    fout.open(argv[1]);
    build();
    
    return 0;

}