#include <bits/stdc++.h>
using namespace std;

void checkNoInput() {
    string K;
    assert(!getline(cin, K));
}

string readLine() {
    string K;
    assert(getline(cin, K));
    return K;
}

long long toLong(const string& K) {
    if (K == "+" || K == "?") return 0 - (K == "+");
    assert(K.size());
    assert(K.size() <= 18);
    long long ans = 0;
    bool sign = 1;
    for (char c: K) {
        assert(isdigit(c) || (sign && c == '-'));
        if (c == '-') sign = 0;
        else ans = 10*ans+c-'0';
    }
    if (!sign) ans = -ans;
    return ans;
}

vector<long long> numbersOnLine() {
    string K = readLine();
    vector<string> v(1);
    for (char c: K) {
        if (c == ' ') v.push_back("");
        else v.back().push_back(c);
    }
    vector<long long> ans;
    for (string& K: v) ans.push_back(toLong(K));
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    vector<bool> groups(8, true);
    vector<int> all;

    vector<long long> first = numbersOnLine();
    assert(first.size() == 1);
    long long N = first[0];
    assert(1 <= N && N <= 100000);
    if (N > 20) groups[2] = 0;
    if (N > 1000) groups[4] = groups[5] = 0;

    first = numbersOnLine();
    assert(first.size() == N);
    for (int i = 0 ; i < N ; ++i) 
    {
        assert(1 <= first[i] && first[i] <= 1'000'000'000);
        if (first[i] > 2) groups[3] = 0;
        if (first[i] > 1000) groups[4] = 0;
        if (first[i] > 100000) groups[6] = 0;
    }

    for (int i = 1; i < groups.size(); i++) {
        if (groups[i]) cout << i << " ";
    }
    cout << endl;

    return 0;
}
