#include<iostream>
#include<assert.h>
#include<map>
#define MAXN 100000
using namespace std;
const int mod=998244353;
int a[MAXN],tree[4*MAXN];
map <int, int> compress;
int query (int ind, int l, int r, int q) {
    if (r<=q) return tree[ind];
    int mid=(l+r)/2,sum=0;
    sum+=query(2*ind+1,l,mid,q);
    if (q>=mid+1) sum+=query(2*ind+2,mid+1,r,q), sum%=mod;
    return sum;
}
void update (int ind, int l, int r, int q, int val) {
    if (l==r) {
        tree[ind]+=val; tree[ind]%=mod;
        return ;
    }
    int mid=(l+r)/2;
    if (q<=mid) update(2*ind+1,l,mid,q,val);
    else update(2*ind+2,mid+1,r,q,val);
    tree[ind]=tree[2*ind+1]+tree[2*ind+2]; tree[ind]%=mod;
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    assert(cin >> n );
    assert((n>=1)&&(n<=MAXN));
    for (int i=0; i<n; i++) {
        assert(cin >> a[i] );
        assert((a[i]>=1)&&(a[i]<=1e9));
        compress[a[i]]=0;
    }
    char temp; assert(!(cin >> temp ));
    int num=0;
    for (auto &[val, code] : compress) {
        code=num++;
    }
    int ans=0,code;
    for (int i=0; i<n; i++) {
        code=compress[a[i]];
        int cnt=(query(0,0,num-1,code)+1);
        ans+=cnt; ans%=mod;
        update(0,0,num-1,code,cnt);
    }
    cout << ans ;
    cout << endl ;
    return 0;
}
