#include <bits/stdc++.h>
#define MAXN 100007
using namespace std;

const int mod=998244353;

int n,cnt,dp[MAXN],fenwick[MAXN];
long long a[MAXN];
vector<long long> v;
unordered_map<long long,int> mp;

int getsum(int x){
    int res=0;
    while(x>=1){
        res+=fenwick[x];
        res%=mod; x-=(x & (-x));
    }
    return res;
}

void update(int x,int val){
    while(x<=n){
        fenwick[x]+=val;
        fenwick[x]%=mod;
        x+=(x & (-x));
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>a[i];
        v.push_back(a[i]);
    }
    sort(v.begin(),v.end());cnt=1;

    for(int i=0;i<v.size();i++){
        mp[v[i]]=cnt;
        if(i<v.size()-1 and v[i]!=v[i+1])cnt++;
    }

    for(int i=1;i<=n;i++){
        a[i]=mp[a[i]];
        dp[i]=(getsum(a[i])+1)%mod;
        update(a[i],dp[i]);
    }

    cout<<getsum(cnt)<<"\n";

    return 0;
}
