#include <iostream>
#include <cstring>

const int maxn = 1000 + 10;
const int module = 998244353;

int a[maxn], n;
int dp[maxn][maxn];
bool bl[maxn][maxn];

int f(int ix, int value) 
{
    if (ix == 0) return 1;
    if (bl[ix][value]) return dp[ix][value];

    bl[ix][value] = 1;
    dp[ix][value] = f(ix-1, value);
    
    if (a[ix] <= value) dp[ix][value] += f(ix-1, a[ix]);
    if (dp[ix][value] >= module) dp[ix][value] -= module;
    
    return dp[ix][value];
}

void solve() 
{    
    int ans = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        ans = (ans + f(i-1, a[i])) % module;
    }

    std::cout << ans << '\n';
}

void fastIO() 
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void read() 
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
        std::cin >> a[i];
}

int main () 
{
    fastIO();
    read();
    solve();

    return 0;
}