#include <iostream>
#include <fstream>
#include <cstring>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <cmath>
#include <time.h>
using namespace std;
const int maxn = 1e6+10, maxk = 1e6+10;

int a[maxn], n, k, max_value, kconst;
bool used[maxn];

unordered_map < int, int > mp;
set < int > s;

ofstream fout;

void build() {

    ifstream fin("constraints.txt");

    int min_n, max_n;
    int mina, maxa;

    fin >> min_n >> max_n;    
    fin >> mina >> maxa;

    n = rand()%(max_n - min_n + 1) + min_n;

    a[1] = 1;
    for (int i = 2 ; i <= n; ++i)
        a[i] = a[i-1] + (rand()%3 > 0);

    int cnt = a[n];
    for (int i = 1 ; i <= cnt ; ++i) {

        int curr;
        do {
            
            curr = rand()%(maxa - mina + 1) + mina;

        } while (s.count(curr) == 1);

        s.insert(curr);

    }

    cnt = 1;
    for (int i : s) 
        mp[cnt++] = i;

    for (int i = 1 ; i <= n ; ++i)
        a[i] = mp[a[i]];

    fout << n << '\n';
    for (int i = 1 ; i <= n ; ++i) {

        if (i >= 2) fout << ' ';
        fout << a[i];

    }

    fout << '\n';

}

int main (int argc, char** argv) {

    srand(time(nullptr));

    if (argc != 2) {

        cout << "There should be exactly one argument - the name of the in file!\n";
        return 0;

    }

    fout.open(argv[1]);
    build();
    
    return 0;

}